#ifndef __CANNW_H
#define __CANNW_H

#include "CanNwConfig.h"
#include "appTask.h"
/***************************************************************/
/*
		          Դ ģ

	οAutosar
	ڣ2018\06\20

*/
/***************************************************************/

/*
	״̬л

	RMS = Repeat Message State      ظϢ״̬
	NOS = Normal Operation State    ״̬
*/
typedef enum
{
	CAN_NW_RESERVED,            	//0   		ȱʡ
	CAN_NW_RMS_SLEEP,				//1		˯ģʽظϢģʽ
	CAN_NW_RMS_PREPARE_SLEEP,		//2   		׼˯ģʽظϢģʽ
	CAN_NW_RMS_NORMAL_OPERATION,	//3		ģʽظϢģʽ
	CAN_NW_RMS_READY_SLEEP,			//4    	׼˯ģʽظϢģʽ
	CAN_NW_NOS_REPEAT_MESSAGE,		//5		ظϢģʽ״̬
	CAN_NW_NOS_READY_SLEEP,         //6   		׼˯ģʽ״̬
	CAN_NW_GOTO_SLEEP,               //7           糬ʱ2.5S˯ģʽ
	CAN_NW_READY_SLEEP 
}CAN_NW_STATE;

/*
	糬ʱ
	ʱ䵥λ10MS
*/
#define NM_TIMEOUT_TIMER_THR     		2000U
#define REPEAT_MESSAGE_TIMER_THR 		1600U
#define WAIT_BUS_SLEEP_TIMER_THR        2000U
#define REPEAT_NW_CYCLE_TIMER_THR       500U
#define NM_NORMAL_CYCLE_TIMER_THR       500U
#define IMMEDIATENM_CYCLE_TIMER_THR     20U
#define NM_TIMEOUT                    	0U
#define T_NM_ImmediateCycleTime         20U



#define PASSIVE_WAKEUP              		0U
#define LOCAL_ACTIVE_WAKEUP             	1U
#define REMOTE_ACTIVE_WAKEUP             	2U


#define SEND_DISABLE                     0
#define SEND_APP_PDU  					 1
#define SEND_NWAPP_PDU                   2

extern unsigned char ucNwSendPduType;

extern CAN_NW_STATE euNwState;

extern unsigned int uiNwTimCnt;
extern unsigned int uiNwToutCnt;
extern unsigned int uiNwRMSCnt;
extern unsigned int uiNwBsSlpCnt;
extern unsigned int uiSetNwPduCycVal;
extern unsigned int uiNwPduCycCnt;
extern unsigned char ucActiveWakeupBit;
extern unsigned char ucNwPowerUpFlg;
extern unsigned char ucRemoteWakupFlg;
extern unsigned char ucNwNetIdelCheck;
extern unsigned char ucNwNetIdelFlg;
extern unsigned char ucPreLocWkpStu;
extern unsigned int uiNwLocWkpOffCnt;
extern unsigned char ImmediateNM_count;
extern unsigned char RepeatMessageReq;
extern unsigned char DiagMsgRcvFlag;
extern unsigned int  DiagCnt;



#define  NW_NET_INACTIVE  0
#define  NW_NET_ACTIVE    1

extern unsigned char ucNetActiveFlg;    //0 ๦ܹرգ1๦ܿ

void CanNwInit(void);
void CanNwHandle(void);




#endif
