#ifndef __CANNWCONFIG_H
#define __CANNWCONFIG_H

#include "r_rl78_can_drv.h"




#define CAN_NWPDU_NUMBER     	4U
#define CAN_ALLPDU_NUMBER       12U

extern unsigned char ucPduNumber;


typedef union{
	 unsigned int Msg_Word[4];
	 unsigned char Msg_Byte[8];
	 struct{
		unsigned char RCP3_Address:8;
		unsigned char RCP3_RMR:1;
		unsigned char :3;
		unsigned char RCP3_AWB:1;
		unsigned char :3;
        unsigned char RCP3_Wakeup_reasons:8;
		unsigned char RCP3_NMSts :1;
		//unsigned char ACP_GatewayRequest :1;
		unsigned char	:7;
		unsigned char RCP3_Stayawake_reasons_1 :1;//32-Reserved
		unsigned char RCP3_Stayawake_reasons_2 :1;//33-KL15
		unsigned char RCP3_Stayawake_reasons_3 :1;//34-Reserved
		unsigned char RCP3_Stayawake_reasons_4 :1;//35-Reserved
		unsigned char RCP3_Stayawake_reasons_5 :1;//36-Reserved
		unsigned char RCP3_Stayawake_reasons_6 :1;//37-Reserved
		unsigned char RCP3_Stayawake_reasons_7 :1;//38-Diagnosis service is in progres
		unsigned char RCP3_Stayawake_reasons_8 :1;//39-Reserved
		
		unsigned char :8;
		unsigned char :8;
		unsigned char :8;
	 }Msg_Part;
}Can_NwMsg_Type;




extern can_frame_t      TxCanNwPdu_436;
extern Can_NwMsg_Type   TxCanNwMsg_6B7;
extern Can_NwMsg_Type   RxCanNwMsg_688;
extern Can_NwMsg_Type   RxCanNwMsg_6B1;
extern Can_NwMsg_Type   RxCanNwMsg_6B2;
extern Can_NwMsg_Type   RxCanNwMsg_6B3;


extern void  Can_Nw_Init(void);


#endif
