
/******************************************************************************
|  File Name :  Dcm.c
|  Description: Ϸ
|------------------------------------------------------------------------------
| (c) This software is the proprietary of Wenzhou Changjiang AutoMobile (DAMING)
|     All rights are reserved by DAMING.
|------------------------------------------------------------------------------
| Initials      Name                   Company
| --------      --------------------   ----------------------------------------
|                				       DAMING
|------------------------------------------------------------------------------
|               R E V I S I O N   H I S T O R Y
|------------------------------------------------------------------------------
| Date         Version    Author       Description
| ----------   --------   ------       ----------------------------------------
| 2015-10-10   1.0.1     chenlianwen   ʼ
 *****************************************************************************/

/******************************************************************************
 * Description:     : Include File Section 									
******************************************************************************/
#include "Dcm.h"
#include "can_drv.h"

/******************************************************************************
 * Description:     : Global Variable Definition Section 									
 ******************************************************************************/
const uint16 PeriodicDidServeTxTmMax[5]={0xFFFF,1000,500,100,0xFFFF};


/******************************************************************************
 * Description:     : Static Variable Definition Section 									
 ******************************************************************************/


/******************************************************************************
 * Description:     : Static Function Prototype Declaration									
 *****************************************************************************/

 static void MngDcm_ConditionStateControl(void);
/******************************************************************************
 * Description:     : Write User Function Code								
 *****************************************************************************/


/******************************************************************************
 *    : void MngDcm_MainFunction(void)

 *        : void

 *ֵ      : void

 *        : ں

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/
 void MngDcm_MainFunction(void)
{
    uint8 LeDcm_u_SidIndex;
    uint8 LeDcm_u_CheckSessionResult;
    uint8 LeDcm_u_CheckSecurityAccessResult;
    uint8 LeDcm_u_CheckAddressResult;
    uint8 LaDcm_u_TempBuffer[6];
    uint8 LeDcm_u_CheckMinDLResult;
    uint8 LeDcm_u_CollectInfoResult;
    TeDcm_h_ResultType LeDcm_u_FinallyResult;
    /**/
    MngDcm_ConditionStateControl();
    
    /*ȡTPݽӿ DL SID */
    LeDcm_u_CollectInfoResult = MngDcm_CollectRequstInfo();
    
    if(DCM_CHECK_OK == LeDcm_u_CollectInfoResult)
    {
		MngDcm_ResetS3serverTime();             /*S3server ʱֵװ*/
        LeDcm_u_SidIndex = MngDcm_SIDCheckAvailable(VeDcm_h_RqustInfo.Sid); /*SIDǷ֧*/
        if( DCM_NORESULT!=LeDcm_u_SidIndex)
        {
    
           LeDcm_u_CheckSessionResult = MngDcm_SIDCheckSession(LeDcm_u_SidIndex);   /*ģʽǷ֧*/ 
           if(DCM_CHECK_OK == LeDcm_u_CheckSessionResult)
           {
       
              LeDcm_u_CheckSecurityAccessResult = MngDcm_SIDCheckSecurityAccess(LeDcm_u_SidIndex);  /*鰲ȫȨǷ*/ 
              if(DCM_CHECK_OK == LeDcm_u_CheckSecurityAccessResult )
              {
                  if(DCM_FUNCTIONAL_ADDRESS == VeDcm_h_RqustInfo.RequstSty)
                  {
                       LeDcm_u_CheckAddressResult = MngDcm_SIDFuncAddressAvailable(LeDcm_u_SidIndex);  /*Ƿֹ֧Ѱַ*/
                       if(DCM_CHECK_NOK == LeDcm_u_CheckAddressResult) /*֧*/
                       {
                           SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
                           LeDcm_u_FinallyResult = CeDcm_e_ResultNoRsp; 
                       } 
                       else
                       {
                           LeDcm_u_CheckMinDLResult = MngDcm_SIDCheckMinDL(LeDcm_u_SidIndex,VeDcm_h_RqustInfo.DL);                    /*ǷСDL*/
                           if( DCM_CHECK_OK == LeDcm_u_CheckMinDLResult)
                          {
                             LeDcm_u_FinallyResult = CaDcm_h_SidCheckInfoTable[LeDcm_u_SidIndex].SidFunction();   /*SIDں*/
                           
                          }    
                          else
                          {
                         
                              //NRC13
                              MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC13]);    /*Ӧ*/
                              SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
                              LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;
                         
                          }
                       } 
                  }
                  else
                  {
              
                      LeDcm_u_CheckMinDLResult = MngDcm_SIDCheckMinDL(LeDcm_u_SidIndex,VeDcm_h_RqustInfo.DL);                    /*ǷСDL*/
                      if( DCM_CHECK_OK == LeDcm_u_CheckMinDLResult)
                      {
                          LeDcm_u_FinallyResult = CaDcm_h_SidCheckInfoTable[LeDcm_u_SidIndex].SidFunction();   /*SIDں*/
                      }
                      else
                      {
                          //NRC13
                          MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC13]);    /*Ӧ*/
                          SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
                          LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;
                      
                     
                      }
                  }
          
              }
              else
              {
                  MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC33]);    /*Ӧ*/
                  SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
                  LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;
              }
          
           }
           else
           {
           
               //NRC7F
               MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC7F]);    /*Ӧ*/
               SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
               LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;
           
           }
     
        }
        else
        {
            if(DCM_FUNCTIONAL_ADDRESS == VeDcm_h_RqustInfo.RequstSty)
            {
                SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
                LeDcm_u_FinallyResult = CeDcm_e_ResultNoRsp; 
            
            }else
            {//NRC11
                MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC11]);    /*Ӧ*/
                SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
                LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;
            }
        }
    }else
    {
        
    }
   
    if(DCM_S3SEVERTIMER_CONTINUE == GetCanTp_u_S3Sts())
    {
        MngDcmS3ServerCountCutDown();        /*S3server ʱ  Կʱʱ*/
    }
    
    MngDcmKeyErrorDelayCountCutDown();                 /*27 Կʱ*/
	
	DtcDiagConditionChk();
	if(GetDtcEnable())
		CanDTC_Task();
}






/******************************************************************************
 *    : void MngDcm_ConditionStateControl(void)
 *        : void

 *ֵ      : void

 *        : ݵǰ(S3severtime)״̬

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/
void MngDcm_ConditionStateControl(void)
{
    if(0U == MngDcm_GetS3serverTime())
    {
       MngDcm_ChangeToDefaltSession();      
    }
    
}


	
