/*@ʵдϢ@ַԼʾȥ*/
/******************************************************************************
|  File Name :  Dcm_Cfg.h
|  Description: 
******************************************************************************/
#ifndef DCM_CFG_H
#define DCM_CFG_H

/******************************************************************************
 * Description:     : Include File Section 									
******************************************************************************/

#include "Dcm_App.h"

/******************************************************************************
 * Description:     : Macro Description Section
******************************************************************************/
#define YES 1
#define NO 0

#define DID_RECORD 			( NO  )
#define SID_RECORD			( YES )

#define DAMING_CAN_BOOT		( NO )
#define DCM_SUPPORTSID_COUNT                 12U        /*ֵ֧SIDĿ*/ 


#define DCM_10SUB_COUNT                    3U        /*10ӷ*/  
#define DCM_11SUB_COUNT                    2U        /*11ӷ*/ 
#define DCM_19SUB_COUNT                    3U        /*19ӷ*/ 


#define DCM_27SUB_COUNT                    2U        /*27ӷ*/ 
#define DCM_28SUB_COUNT                    3U        /*28ӷ*/

#define DCM_31RID_COUNT                    1U        /*31ӷ*/
#define DCM_RIDFF02_SUB_COUNT              3U        /*31 FF02 ֵ֧ӷ*/
#define DCM_RIDFF00_SUB_COUNT              3U        /*31 FF00 ֵ֧ӷ*/
#define DCM_RIDFF01_SUB_COUNT              3U        /*31 FF01 ֵ֧ӷ*/
#define DCM_RIDF001_SUB_COUNT			   3U		 /* 31 F001 ֵ֧ӷ */

#define DCM_3ESUB_COUNT                    1U        /*3Eӷ*/
#define DCM_85SUB_COUNT                    2U        /*85ӷ*/  
#define DCM_2CSUB_COUNT                    2U        /*2Cӷ*/  
#define DCM_14DTCGROUP_COUNT               3U        /*14ֵ֧DTC*/  

#if (defined (DAMING_CAN_BOOT) && (DAMING_CAN_BOOT == YES))
#define DCM_READ_DIDSUP_COUNT               15U       /*22 ֵ֧DID  */ 
#else
#define DCM_READ_DIDSUP_COUNT             24U       /* 22 ֵ֧DID  */ 
#endif
#define DCM_IO_DIDSUP_COUNT                 5U       /*2F ֵ֧DID */ 
#define DCM_PERIODIC_DATA_COUNT				0U		/*2A ֧DID */

#define DCM_WRITE_DIDSUP_COUNT              7U        /*2E ֵ֧DID */ 
#define DCM_ONEDID_MAXDATALENGTH           20U        /*22 DID 󳤶*/ 



/******************************************************************************
 * Description:     : Structure Type Declaration Section
******************************************************************************/


#define ROUTINECTRL_DID_CheckProgrammingIntegrity		0x0202
#define ROUTINECTRL_DID_CheckProgrammingPreconditions	0x0203
#define ROUTINECTRL_DID_CheckProgrammingDependencies	0xFF01
#define ROUTINECTRL_DID_EraseMemory						0xFF00


typedef TeDcm_h_ResultType (*ServerDealfunc)(void);
/*SID  */
typedef struct
{
  uint8  SupportSession;  /*ֵ֧ĻỰģʽ*/
  uint8  SupportSecurityAccess;   /*ֵ֧İȫȨ*/
  uint8  SupportRequestAddress;   /*ֵ֧ʽ*/
  uint8  MinDL;           /*SID ӦСDL*/
  uint8  SubCount;        /*ӷ */
  uint8  Sid;             /*SID */
  ServerDealfunc SidFunction;
}TsDcm_h_SidCheckInfoType;



typedef TeDcm_h_ResultType (*SubDealfunc)(void );
typedef TeDcm_h_ResultType (*SubDealfuncWithPara)(uint8 );
/*ӷϢбṹ*/
typedef struct
{
  uint8 Sub;                         /*ӷ*/
  uint8 DL;                          /*ӷ ӦȷDL*/
  SubDealfunc SubFunction;         /*ӷ ӦĴ*/
}TsDcm_h_SubCheckType;

typedef struct
{
	uint8 Sub;                         /*ӷ*/
	uint8 DL;                          /*ӷ ӦȷDL*/
	SubDealfuncWithPara SubFunction;         /*ӷ ӦĴ*/
}TsDcm_h_WithParaSubCheckType;



/*ӷϢбṹ*/
typedef struct
{
  uint8 Sub;                         /*ӷ*/
  uint8 DL;                          /*ӷ ӦȷDL*/
  SubDealfunc SubFunction;         /*ӷ ӦĴ*/
}TsDcm_h_DtcCheckType;


typedef uint8 (*DidDealfunc)(uint8* LeDcm_u_DataAddress,uint8* LeDcm_u_DataLength);
/* 22 2E 2A DID Ϣбṹ*/
typedef struct
{   
  uint8  SupportSession;                    /*ֵ֧ĻỰģʽ*/
  uint8  SupportSecurityAccess;             /*ֵ֧İȫȨ*/
  uint8  DataLength;                        /*ݳ*/
  uint16  Did;                               /*DID*/
  DidDealfunc Function;                        /*DID ӦĴ*/
}TsDcm_h_DidCheckType;

typedef struct
{
	uint8 Did;
	uint8 TransmissionMode;
	uint16 TmCount;
}TsDcm_h_2APeriodicDidServe;

typedef TeDcm_h_ResultType (*DtcDealfunc)(uint32 LeDcm_DtcGroup);
/*14 Ϣбṹ*/
#if 0
typedef struct
{ 
  uint32 Dtc;                           /* DTC */
  DtcDealfunc CleanFunction;         /* ӷ ӦĴ */
}TsDcm_h_DtcCheckType;

#endif



typedef TeDcm_h_ResultType (*RidDealfunc)(void);
/*Rid ֵ֧ӷ񼰴Ϣбṹ*/           
typedef struct
{ 
  
  uint8 Sub;                         /*ӷ*/
  uint8 DL;                          /* ӦȷDL*/
  RidDealfunc Function;              /* ӦĴ*/
}TsDcm_h_RidSubCheckType;



/* 31 RID Ϣбṹ*/
typedef struct
{  
  uint8  SupportSession;                    /*ֵ֧ĻỰģʽ*/
  uint8  SupportSecurityAccess;             /*ֵ֧İȫȨ*/
  uint16 Rid;                               /*Rid*/
  const TsDcm_h_RidSubCheckType* RidSubTable;     /*Rid ֵ֧ӷб*/
  
}TsDcm_h_RidCheckType;

typedef struct
{
	uint8 write;
	uint8 data;
}TsDcm_h_IO_parameter_t;

/******************************************************************************
 * Description:     : Global Variable Declaration Section
******************************************************************************/


extern const TsDcm_h_SidCheckInfoType CaDcm_h_SidCheckInfoTable[DCM_SUPPORTSID_COUNT];



/******************************************************************************
 * Description:     : Global Function Prototype Declaration	
******************************************************************************/

extern uint8 MngDcm_SIDCheckAvailable(uint8 LeDcm_u_Sid);
extern uint8 MngDcm_SIDCheckSession(uint8 LeDcm_u_SidIndex);
extern uint8 MngDcm_SIDCheckSecurityAccess(uint8 LeDcm_u_SidIndex);
extern uint8 MngDcm_SIDFuncAddressAvailable(uint8 LeDcm_u_SidIndex);
extern uint8 MngDcm_SIDCheckMinDL(uint8 LeDcm_u_SidIndex,uint16 LeDcm_u_DL);

extern TeDcm_h_ResultType MngDcm_SessionControlService(void);
extern TeDcm_h_ResultType MngDcm_ECUResetService(void);
extern TeDcm_h_ResultType MngDcm_CleanDTCService(void);
extern TeDcm_h_ResultType MngDcm_ReportDTCService(void);
extern TeDcm_h_ResultType MngDcm_ReadDidDataService(void);
extern TeDcm_h_ResultType MngDcm_SecurityAccessService(void);
extern TeDcm_h_ResultType MngDcm_CommunicationControlService(void);
extern TeDcm_h_ResultType MngDcm_WriteDidDataService(void);
extern TeDcm_h_ResultType MngDcm_RoutineControlService(void);
extern TeDcm_h_ResultType MngDcm_TesterPresentService(void);
extern TeDcm_h_ResultType MngDcm_DTCSettingControlService(void);

extern  TeDcm_h_ResultType MngDcm_ReadMemoryDataService(void);
extern  TeDcm_h_ResultType MngDcm_SecurityAccessService(void);
extern  TeDcm_h_ResultType MngDcm_WriteMemoryDataService(void);
extern  TeDcm_h_ResultType MngDcm_ReadDataByIdentifier(void);
extern  TeDcm_h_ResultType MngDcm_ReadDTCInfoService(void);
extern	TeDcm_h_ResultType MngDcm_DynamicaDefineIdentifier(void);			
extern	TeDcm_h_ResultType MngDcm_IOCtrlDIDService(void);
extern	TeDcm_h_ResultType MngDcm_DynamicaDefineIdentifier(void);
#endif
