#ifndef __PINDEF_H__
#define __PINDEF_H__

#include "iodefine.h"

#define CAN_STB			P1_bit.no2


#define O_IND1_CTRL       P1_bit.no5
#define O_IND2_CTRL       P1_bit.no6
#define O_IND3_CTRL       P1_bit.no7
#define O_IND4_CTRL       P3_bit.no0
#define O_IND5_CTRL       P4_bit.no1
#define O_IND6_CTRL       P12_bit.no0

#define I_SW_LOCK_IN     P6_bit.no3
#define I_SW_L_IN       P6_bit.no2
#define I_SW_RE1        P6_bit.no0
#define I_SW_RE2        P6_bit.no1

typedef enum
{
    SIGID_SW_LOCK_IN,
    SIGID_SW_L_IN,
    SIGID_SW_P_IN,
    SIGID_SW_RE2,
    SIG_NUM,
}SIGID_type;


typedef enum
{
    ADCH_IGN,
    ADCH_HALL_F,
    ADCH_HALL_N,
    ADCH_HALL_R,
    ADCH_NUM,
}ADCH_type;



#endif

