



#include "CanNw.h"




unsigned char ucPduNumber;
can_frame_t TxCanNwPdu_436;
Can_NwMsg_Type TxCanNwMsg_6B7;
Can_NwMsg_Type RxCanNwMsg_688;
Can_NwMsg_Type RxCanNwMsg_6B1;
Can_NwMsg_Type RxCanNwMsg_6B2;
Can_NwMsg_Type RxCanNwMsg_6B3;


void Can_Nw_TXMsg_Init(void);
void Can_Nw_RXMsg_Init(void);



void Can_Nw_TXMsg_Init(void)
{

	Can_init_id(&TxCanNwPdu_436,0x436);

	TxCanNwMsg_6B7.Msg_Part.RCP3_Address=0x36;
	TxCanNwMsg_6B7.Msg_Part.RCP3_RMR=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_AWB=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_NMSts=0;
    TxCanNwMsg_6B7.Msg_Part.RCP3_Wakeup_reasons=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_Stayawake_reasons_1=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_Stayawake_reasons_2=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_Stayawake_reasons_2=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_Stayawake_reasons_4=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_Stayawake_reasons_5=0;
  	TxCanNwMsg_6B7.Msg_Part.RCP3_Stayawake_reasons_6=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_Stayawake_reasons_7=0;
	TxCanNwMsg_6B7.Msg_Part.RCP3_Stayawake_reasons_8=0;

	Copy_Array_to_Array(TxCanNwPdu_436.DB,TxCanNwMsg_6B7.Msg_Byte,8);

}


void Can_Nw_RXMsg_Init(void)
{

	RxCanNwMsg_688.Msg_Part.RCP3_Address=0x00;
	RxCanNwMsg_688.Msg_Part.RCP3_RMR=0;
	RxCanNwMsg_688.Msg_Part.RCP3_AWB=0;
	RxCanNwMsg_688.Msg_Part.RCP3_NMSts=0;
    RxCanNwMsg_688.Msg_Part.RCP3_Wakeup_reasons=0;
	RxCanNwMsg_688.Msg_Part.RCP3_Stayawake_reasons_1=0;
	RxCanNwMsg_688.Msg_Part.RCP3_Stayawake_reasons_2=0;
	RxCanNwMsg_688.Msg_Part.RCP3_Stayawake_reasons_2=0;
	RxCanNwMsg_688.Msg_Part.RCP3_Stayawake_reasons_4=0;
	RxCanNwMsg_688.Msg_Part.RCP3_Stayawake_reasons_5=0;
  	RxCanNwMsg_688.Msg_Part.RCP3_Stayawake_reasons_6=0;
	RxCanNwMsg_688.Msg_Part.RCP3_Stayawake_reasons_7=0;
	RxCanNwMsg_688.Msg_Part.RCP3_Stayawake_reasons_8=0;

	
}


void Can_Nw_Init(void)
{
	ucPduNumber = CAN_ALLPDU_NUMBER;
	Can_Nw_TXMsg_Init();
	Can_Nw_RXMsg_Init();
}




