
#if !defined(COM_TYPE_H)
#define COM_TYPE_H

typedef unsigned char ComUint8;
typedef unsigned short ComUint16;
typedef unsigned long ComUint32;
typedef unsigned char ComStd_ReturnType;

#define COM_E_OK       0U
#define COM_E_NOT_OK   1U
#define COM_E_PENDING  2U

#define COM_TRUE       1U
#define COM_FALSE      0U

#ifndef COM_NULL_PTR
#define COM_NULL_PTR  0L
#endif

#ifndef COM_STD_ON
#define COM_STD_ON  1U
#endif

#ifndef COM_STD_OFF
#define COM_STD_OFF  0U
#endif

#ifndef __TYPEDEF__
typedef signed char         int8_t;
typedef unsigned char       uint8_t;
typedef signed short        int16_t;
typedef unsigned short      uint16_t;
typedef signed long         int32_t;
typedef unsigned long       uint32_t;
typedef unsigned short      MD_STATUS;
#define __TYPEDEF__
#endif

#endif

