/******************************************************************************
|  File Name :  DCM_Types.h
|  Description: Company standard definition
******************************************************************************/
#ifndef DCM_TYPES_H
#define DCM_TYPES_H

/******************************************************************************
 * Description:     : Include File Section 									
******************************************************************************/


/******************************************************************************
 * Description:     : Macro Description Section
******************************************************************************/

typedef signed char		int8;
typedef signed int		int16;
typedef signed long		int32;
typedef unsigned char	uint8;
typedef unsigned int	uint16;
typedef unsigned long	uint32;
typedef unsigned char   bool1;
typedef union{
	uint32 word;
	uint8 byte[4];
}long2char_t;

#ifndef DCM_ON
#  define DCM_ON    1U
#endif

#ifndef DCM_OFF
#define DCM_OFF    0U
#endif


#ifndef DCM_TRUE
#  define DCM_TRUE    1U
#endif

#ifndef DCM_FALSE
#  define DCM_FALSE    0U
#endif


#ifndef DCM_HIGH
#  define DCM_HIGH    1U
#endif

#ifndef DCM_LOW
#  define DCM_LOW    0U
#endif


#ifndef DCM_ACTIVE
#  define DCM_ACTIVE    1U
#endif

#ifndef DCM_INACTIVE
#  define DCM_INACTIVE    0U
#endif


#ifndef DCM_NULL
#  define DCM_NULL    0U
#endif

/* NULL_PTR define with a void pointer to zero definition*/
#ifndef DCM_NULL_PTR
#  define DCM_NULL_PTR  ((void *)0)
#endif

/******************************************************************************
 * Description:     : Structure Type Declaration Section
******************************************************************************/


/******************************************************************************
 * Description:     : Global Variable Declaration Section
******************************************************************************/


/******************************************************************************
 * Description:     : Global Function Prototype Declaration	
******************************************************************************/


#endif
