	
/******************************************************************************
|  File Name : Dcm_App.c
|  Description: Ϸ崦
 *****************************************************************************/

/******************************************************************************
 * Description:     : Include File Section 									
******************************************************************************/
#include "r_cg_macrodriver.h"
#include "Dcm_App.h"
#include "Dcm_extern.h"
#include "r_cg_userdefine.h"
#include "pfdl.h"

/******************************************************************************
 * Description:     : Global Variable Definition Section 									
 ******************************************************************************/
 
TsDcm_h_RquestInfo VeDcm_h_RqustInfo;             /*ȡϢĽṹ*/
uint8 VaDcm_u_NegRspTxBuffer[3];                  /*ӦݵĻ*/



uint8* VeDcm_P_DataAddress ;                      /*TPݵַ*/

//uint32_t ReprogmaValid = 0xAA5555AA;


/******************************************************************************
 * Description:     : Static Variable Definition Section 									
 ******************************************************************************/


static uint16 SeDcm_u_DL;                                      /*TPݳ*/
static uint8 SeDcm_u_RequstSty;                                /*TPʽ*/


static uint16 SeDcm_w_S3ServerTime;                            /*S3ServerTime*/
static uint8 SeDcm_u_S3ServerTimeSts;                          /*S3״̬    ֹͣ*/
static uint8 SeDcm_u_DiagnosticSession ;                       /*ϻỰģʽ*/    
static uint8 SeDcm_u_SecurityAccessState;                      /*ȫȨ״̬*/
static uint8 SeDcm_u_DtcSetSts;                                /*DTC״̬*/
static uint8 SeDcm_u_NetworkMsgSts;                            /*շȨ״̬*/
//static 
uint8 SeDcm_u_NormalMsgSts;                             /*ӦñշȨ״̬*/

static uint16 SeDcm_u_KeyErrorCount;                                     /*27 Կ*/
static uint16 SeDcm_u_KeyErrorDelayCount;                                /*27 Կʱ*/
static uint8 SaDcm_u_RequestCounter;	                                /*27  */
static uint16 SaDcm_u_RequestDelayCount;

static uint8 SeDcm_u_SecurityAccessServerSts;                            /*27 ״̬*/

static uint16 CeDcm_u_P2serverTime = 0x0032;                             /* P2server ʱ 궨*/
static uint16 CeDcm_u_P2ExtserverTime = 0x00C8;                          /* P2*server ʱ 궨*/

static uint32 SeDcm_w_SecurityAccessSeed = 0x12345678;                   /*27  */
static uint32 SeDcm_u_SecurityAccessKey;                                /*27 Կ*/
static uint32 CeDcm_w_SecurityAccessFBLMask = 0xAC856D89;                /*27 */

static TeDcm_e_DownLoadStsType SeDcm_u_DownLoadDataSts;                       /*34 36 37  ط״̬*/
static uint32 SeDcm_w_DownLoadDataLength;                                     /*34 صݳ*/
static uint32 SeDcm_w_TransmitDataCount;                                      /*36 Ѵ*/
static uint8  SeDcm_u_BlockSequenceCountSts;                                  /*36 */
static uint16 CaDcm_w_SingleAllowDateLength = 0x03E8;

static TeDcm_e_RidStsType SeDcm_u_RidFF02Sts;                                              /* FF02 ״̬*/
static TeDcm_e_RidStsType SeDcm_u_RidFF00Sts;                                              /* FF00 ״̬*/
static TeDcm_e_RidStsType SeDcm_u_RidFF01Sts;                                              /* FF01 ״̬*/
static TeDcm_e_RidStsType SeDcm_u_RidF001Sts;                                              /* F001 ״̬*/
static RidRunSts_T	RidFF02RunSts;														   /*   FF02 ִ  */

static DcmReset_T DcmResetReady;
/******************************************************************************
 * Description:     : Static Function Prototype Declaration									
 *****************************************************************************/

static void MngDcm_CleanRequstInfo(void);


unsigned char DF_Write(unsigned char* write_buf,unsigned char data_num,unsigned char len);
RidRunSts_T GetRidFF02RunSts(void);
void CleanIoDid(void);

/******************************************************************************
 * Description:     : Write User Function Code								
 *****************************************************************************/

/******************************************************************************
 *    : void MngDcm_CleanRequstInfo(void)

 *        : void

 *ֵ      : void

 *        : Ϣ

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/
void MngDcm_CleanRequstInfo(void)
{
    uint8 i;
    VeDcm_h_RqustInfo.DL= 0x00;               /*Чֽڳ*/
    VeDcm_h_RqustInfo.Sid = 0x00;              /*SID*/
    VeDcm_h_RqustInfo.RequstSty = 0x00;        /*ʽ*/
    VeDcm_h_RqustInfo.Sub = 0x00;               /*ӷ*/
    
    for(i = 0;i < 3;i++)                        
    {
        VeDcm_h_RqustInfo.DtcGroup[i] = 0x00;     /*DTC*/
    }
                    
    VeDcm_h_RqustInfo.StateMask = 0x00;                   /* ״̬*/
    
    for(i = 0;i < 4;i++)                        
    {
        VeDcm_h_RqustInfo.Key[i] = 0x00;                 /*ԿϢ*/
    }
                       
    VeDcm_h_RqustInfo.CommType = 0x00;                    /*ͨѶ*/
    
    for(i = 0;i < DCM_READDID_MAXNUMBER*2 ;i++)                        
    {
        VeDcm_h_RqustInfo.Did[i] = 0x00;                  /*DID*/
    }
      
    VeDcm_h_RqustInfo.DidCount = DCM_NULL;                    /*DID*/
    VeDcm_h_RqustInfo.Rid = 0x00;                           /*дĿDID*/
     
    for(i = 0;i < DCM_WRITEDATA_MAXLENGTH;i++)                        
    {
        VeDcm_h_RqustInfo.WriteData[i] = 0x00;                   /*д*/
    }
    
} 


/******************************************************************************
 *    : uint8 MngDcm_CollectRequstInfo(void)

 *        : void

 *ֵ      : LeDcm_TempResult  ݻȡ ȡɹʧ

 *        : TPȡϢ  ʽDL sid

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/
uint8 MngDcm_CollectRequstInfo(void)
{  
    uint8 LeDcm_TempResult = DCM_CHECK_NOK;
    MngDcm_CleanRequstInfo();           /* */
    
    
    if(CeCanTp_e_Full == GetCanTp_e_RxBufferSts(&SeDcm_u_RequstSty,&SeDcm_u_DL,&VeDcm_P_DataAddress))
    {
        LeDcm_TempResult = DCM_CHECK_OK;											
        if(CeCanTp_e_Physical ==SeDcm_u_RequstSty)
        {
            VeDcm_h_RqustInfo.RequstSty = DCM_PHYSICAL_ADDRESS;    
        }
        else
        {
            VeDcm_h_RqustInfo.RequstSty = DCM_FUNCTIONAL_ADDRESS;
        }
            
        VeDcm_h_RqustInfo.DL = SeDcm_u_DL;                       
        VeDcm_h_RqustInfo.Sid = VeDcm_P_DataAddress[0];
    }
    else
    {}
    
    return LeDcm_TempResult; 
            
}
 


/******************************************************************************
 *    : uint8 MngDcm_DtcAvailableCheck(uint8* LeDcm_u_Dtc,const TsDcm_h_DtcGroupType LeDcm_u_DtcTable[])

 *        : LeDcm_u_Dtc            ҪҵDTC
                LeDcm_u_DtcTable[]     ֵ֧DTCб

 *ֵ      : LeDcm_u_TempResult  ݻȡ ȡɹʧ

 *        : DTCǷ֧

 *༭ʱ    : 2015-10-23

 *ע        : 
 *****************************************************************************/
uint8 MngDcm_DtcAvailableCheck(uint8* LeDcm_u_Dtc,const TsDcm_h_DtcGroupType LeDcm_u_DtcTable[])
{
    uint8 i;
    uint8 LeDcm_u_TempResult = DCM_NORESULT;
    for(i=0 ; i < DCM_SUPDTC_COUNT; i++)
    {
        if((LeDcm_u_Dtc[0] == LeDcm_u_DtcTable[i].DtcHigh)&&(LeDcm_u_Dtc[1] == LeDcm_u_DtcTable[i].DtcMiddle)&&(LeDcm_u_Dtc[2] == LeDcm_u_DtcTable[i].DtcLow))
        {
             LeDcm_u_TempResult = i;
             break;
        }
    }
    
    return LeDcm_u_TempResult;
}



/******************************************************************************
 *    : uint8 MngDcm_ExtDataRecordAvailableCheck(uint8 LeDcm_u_ExtDataRecord,const DTCExtDataRecordType LeDcm_u_ExtDataRecordTable[])

 *        : LeDcm_u_ExtDataRecord            ExtDataRecord
                ExtDataRecordTable[]             ֵ֧ExtDataRecordϢб

 *ֵ      : LeDcm_u_TempResult  ݻȡ ȡɹʧ

 *        :  ExtDataRecord Ƿ֧

 *༭ʱ    : 2015-10-23

 *ע        : 
 *****************************************************************************/
uint8 MngDcm_ExtDataRecordAvailableCheck(uint8 LeDcm_u_ExtDataRecord,const DTCExtDataRecordType LeDcm_u_ExtDataRecordTable[])
{
    uint8 i;
    uint8 LeDcm_u_TempResult = DCM_NORESULT;
    for(i=0 ; i < DCM_19SUPDTCEXTDATARECORD_COUNT; i++)
    {
        if(LeDcm_u_ExtDataRecord == LeDcm_u_ExtDataRecordTable[i].DTCExtDataRecordNumber)
        {
             LeDcm_u_TempResult = i;
             break;
        }
    }
    
    return LeDcm_u_TempResult;
}
 
 
 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_DefaultSessionDeal(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        :  ĬϻỰģʽ 

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/
 TeDcm_h_ResultType MngDcm_DefaultSessionDeal(void)
 {
     uint8 LaDcm_u_TempBuffer[6];
     TeDcm_h_ResultType LeDcm_u_Result;
     uint32  DcmResetDelay;
      
     SeDcm_u_S3ServerTimeSts = DCM_S3SEVERTIMER_STOP;         /*S3server ʱֹͣ*/
	 if( DCM_PROGRAMME_SESSION == SeDcm_u_DiagnosticSession)
		 DcmResetReady = DCM_RESET_READY;
     SeDcm_u_DiagnosticSession = DCM_DEFAULT_SESSION;       /*Ựģʽ Ĭģʽ*/
     SeDcm_u_SecurityAccessState = DCM_SECURITYACCESS_DEFAULT;  /*ȫģʽ*/
     SeDcm_u_DtcSetSts = DCM_DTCSET_ENABLE;                   /*DTCʹ*/
     SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;              /*շʹ*/
     SeDcm_u_NormalMsgSts = DCM_MSGTXRX_ENABLE | (DCM_MSGTXRX_ENABLE<<1);            /*Ӧñշʹ*/    
	 //CleanIoDid();
     
     if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))          /*жӦλ*/  
     {
         LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;    
         LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
         LaDcm_u_TempBuffer[2] = (uint8)(CeDcm_u_P2serverTime>>8);
         LaDcm_u_TempBuffer[3] = (uint8)(CeDcm_u_P2serverTime&0xFF);
         LaDcm_u_TempBuffer[4] = (uint8)(CeDcm_u_P2ExtserverTime>>8);
         LaDcm_u_TempBuffer[5] = (uint8)(CeDcm_u_P2ExtserverTime&0xFF);
     
         SetCanTp_TxBuffer(6U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultPosRsp;
     }
     else
     {   
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNoRsp;          /*ΪӦ*/
     }
	 
	 if( DCM_RESET_READY == DcmResetReady)
	 {
		while(++DcmResetDelay < 80000);
		SetMcu_SoftReset();
     }
       
     return LeDcm_u_Result;
 }
 
  
 /******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_ProgramSessionDeal(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        :  ̻Ựģʽ 

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/
 TeDcm_h_ResultType MngDcm_ProgramSessionDeal(void)
 {     
	 uint8 LaDcm_u_TempBuffer[6];
	 uint32 ResetDelayCnt = 0;
     TeDcm_h_ResultType LeDcm_u_Result;
      
     SeDcm_u_S3ServerTimeSts = DCM_S3SEVERTIMER_CONTINUE;      /*S3server ʱ*/
     SeDcm_w_S3ServerTime = DCM_S3SEVERTIMEOUT;               /*S3server ʱֵװ*/
	 if( DCM_DEFAULT_SESSION != SeDcm_u_DiagnosticSession )
	 {	
		// 78
		//MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC78]);  
		//SetCanTp_Tx_78Neg(3U,VaDcm_u_NegRspTxBuffer); 
		
		SeDcm_u_DiagnosticSession = DCM_PROGRAMME_SESSION;           /*Ựģʽģʽ*/
		SeDcm_u_SecurityAccessState = DCM_SECURITYACCESS_DEFAULT;   /*ȫģʽ */
		SeDcm_u_DtcSetSts = DCM_DTCSET_ENABLE;                    /*DTCʹ*/
		SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;               /*շʹ*/
		SeDcm_u_NormalMsgSts = DCM_MSGTXRX_DISENABLE;             /*Ӧñշʹ*/
		//ReprogmaValid = 0xAA5555AA;
		//if( 0 == DF_Write((uint8*)(&ReprogmaValid),GetIndexNumber(INDEX_REPROGMA),sizeof(ReprogmaValid)))		//R_FDL_OK => 0
		if(1)
		{
			KamData.boot_enable = RPRGRM_REQ_VALID;
			if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))           /*жӦλ*/
			{
				KamData.AckReq = ACK_REQ;
				KamData.AckLenth = 7;		
				KamData.RspData[0] = 0x06;
				KamData.RspData[1] = VeDcm_h_RqustInfo.Sid + 0x40;
				KamData.RspData[2] = VeDcm_h_RqustInfo.Sub;
				KamData.RspData[3] = (uint8)(CeDcm_u_P2serverTime>>8);
				KamData.RspData[4] = (uint8)(CeDcm_u_P2serverTime&0xFF);
				KamData.RspData[5] = (uint8)(CeDcm_u_P2ExtserverTime>>8);
				KamData.RspData[6] = (uint8)(CeDcm_u_P2ExtserverTime&0xFF);
				KamData.RspData[7] = 0x55;
#if 0
				LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
				LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
				LaDcm_u_TempBuffer[2] = (uint8)(CeDcm_u_P2serverTime>>8);
				LaDcm_u_TempBuffer[3] = (uint8)(CeDcm_u_P2serverTime&0xFF);
				LaDcm_u_TempBuffer[4] = (uint8)(CeDcm_u_P2ExtserverTime>>8);
				LaDcm_u_TempBuffer[5] = (uint8)(CeDcm_u_P2ExtserverTime&0xFF);
				while(++ResetDelayCnt < 100000);
				SetCanTp_TxBuffer(6U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
#endif
				LeDcm_u_Result = CeDcm_e_ResultPosRsp;
			}
			else
			{
				KamData.AckReq = 0;
				SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
				LeDcm_u_Result = CeDcm_e_ResultNoRsp;          /*ΪӦ*/
			}
			//ResetDelayCnt = 0;
			//while(++ResetDelayCnt < 10000);
			SetMcu_SoftReset();
		}
		else
		{
			/*NRC 22*/
			MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC22]);    /*Ӧ*/
			SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
			LeDcm_u_Result = CeDcm_e_ResultNegRsp;
		}
	}
	else
	{
		if(DCM_FUNCTIONAL_ADDRESS == VeDcm_h_RqustInfo.RequstSty)
         {
            SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
            LeDcm_u_Result = CeDcm_e_ResultNoRsp; 
         }
         else
         {
    		MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC7E]);    /*Ӧ*/
    		SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
    		LeDcm_u_Result = CeDcm_e_ResultNegRsp;
		}
	}
     return LeDcm_u_Result;
 }
 
 /******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_ExtendedSessionDeal(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        :  չỰģʽ 

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/
 TeDcm_h_ResultType MngDcm_ExtendedSessionDeal(void)
 {
     uint8 LaDcm_u_TempBuffer[6];
     TeDcm_h_ResultType LeDcm_u_Result;
      
     SeDcm_u_S3ServerTimeSts = DCM_S3SEVERTIMER_CONTINUE;         /*S3server ʱ*/
     SeDcm_w_S3ServerTime = DCM_S3SEVERTIMEOUT;                  /*S3server ʱֵװ*/
	 if(SeDcm_u_DiagnosticSession != DCM_EXTEND_SESSION)
	 {
		SeDcm_u_DtcSetSts = DCM_DTCSET_ENABLE;                       /*DTCʹ*/
		SeDcm_u_DiagnosticSession = DCM_EXTEND_SESSION;              /*Ựģʽ չģʽ*/
		SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;                  /*շʹ*/
		SeDcm_u_NormalMsgSts = DCM_MSGTXRX_ENABLE | (DCM_MSGTXRX_ENABLE<<1);                /*Ӧñշʹ*/
	 }
	 
	 SeDcm_u_SecurityAccessState = DCM_SECURITYACCESS_DEFAULT;      /*ȫģʽ */
     
     if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))              /*жӦλ*/
     {
         LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
         LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
         LaDcm_u_TempBuffer[2] = (uint8)(CeDcm_u_P2serverTime>>8);
         LaDcm_u_TempBuffer[3] = (uint8)(CeDcm_u_P2serverTime&0xFF);
         LaDcm_u_TempBuffer[4] = (uint8)(CeDcm_u_P2ExtserverTime>>8);
         LaDcm_u_TempBuffer[5] = (uint8)(CeDcm_u_P2ExtserverTime&0xFF);
         
         //SeDcm_u_SecurityAccessState = DCM_SECURITYACCESS_L2_UNLOCK;    /*ðȫȨΪ ״̬ */
     
         SetCanTp_TxBuffer(6U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultPosRsp;
     }
     else
     {
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNoRsp;          /*ΪӦ*/
     }
       
     return LeDcm_u_Result;
}
 
/******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_SoftResetDeal(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 11 03 λ 

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
TeDcm_h_ResultType MngDcm_SoftResetDeal(void)
{
    uint8 LaDcm_u_TempBuffer[2];
    TeDcm_h_ResultType LeDcm_u_Result;
	static uint32 ResetDelayCnt;
     
    //ECUӿ
	if(SeDcm_u_DiagnosticSession != DCM_DEFAULT_SESSION)
	{
        if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))              /*жӦλ*/
        {  
    		KamData.AckReq = ACK_REQ;
    		KamData.AckLenth = 3;		
    		KamData.RspData[0] = 0x02;
    		KamData.RspData[1] = VeDcm_h_RqustInfo.Sid + 0x40;
    		KamData.RspData[2] = VeDcm_h_RqustInfo.Sub;
    		KamData.RspData[3] = 0x55;
    		KamData.RspData[4] = 0x55;
    		KamData.RspData[5] = 0x55;
    		KamData.RspData[6] = 0x55;
    		KamData.RspData[7] = 0x55;
#if 0
            LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
            LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;     
         
            SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
#endif
    		LeDcm_u_Result = CeDcm_e_ResultPosRsp;
        }
    	else
        {
    		KamData.AckReq = 0;
            SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
            LeDcm_u_Result = CeDcm_e_ResultNoRsp;          /*ΪӦ*/
        }
        if(LeDcm_u_Result == CeDcm_e_ResultPosRsp)
    	{
#if 0
    		while(ResetDelayCnt < 0x80000)
    		{	
    			ResetDelayCnt++;
    		}
#endif
    		SetMcu_SoftReset();
    	}
    	else
    		SetMcu_SoftReset();
	}
	else
	{
	    if(DCM_FUNCTIONAL_ADDRESS == VeDcm_h_RqustInfo.RequstSty)
         {
            SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
            LeDcm_u_Result = CeDcm_e_ResultNoRsp; 
         }
         else
         {
    		MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC7F]);    /*Ӧ*/
    		SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
    		LeDcm_u_Result = CeDcm_e_ResultNegRsp;
		}
	}
    return LeDcm_u_Result;
}
 
 
 

 
 
 
 
 
 
 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_RequestSeekDeal( uint8 SecurityLevel)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 27   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_RequestSeekDeal( uint8 SecurityLevel)
 {
     uint8 LaDcm_u_TempBuffer[6],savebuf[4];
     TeDcm_h_ResultType LeDcm_u_Result;
		 //SeDcm_u_KeyErrorDelayCount = 0;

	 if(SaDcm_u_RequestCounter < 5)
	 {
    	 SaDcm_u_RequestCounter++;
    	 KamData.SeedReqTimes = SaDcm_u_RequestCounter | 0x10;
    	 if(SaDcm_u_RequestCounter == 5)
    	 {
    	    SaDcm_u_RequestDelayCount = DCM_SASERVERSTS_ERRORDELAY_COUNT;
    	    SeDcm_u_KeyErrorCount = 3;
    	    KamData.KeyErrTimes = SeDcm_u_KeyErrorCount | 0x10;
    	 }
    	 
    	 ReadFlashData(savebuf,0x000F1800,4);
    	 savebuf[0] = SaDcm_u_RequestCounter;
    	 savebuf[1] = SeDcm_u_KeyErrorCount;
    	 WriteDataflash(savebuf,0x000F1800,4);
    	 
	 }//fcb
	 
     if(0==SeDcm_u_KeyErrorDelayCount && 0==SaDcm_u_RequestDelayCount)
     {   
         if(SaDcm_u_RequestCounter == 5)
         {
            SaDcm_u_RequestCounter=0;
            KamData.SeedReqTimes = 0;
            
            ReadFlashData(savebuf,0x000F1800,4);
        	savebuf[0] = SaDcm_u_RequestCounter;
        	savebuf[1] = SeDcm_u_KeyErrorCount;
        	WriteDataflash(savebuf,0x000F1800,4);
        	
         }
         
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))                  /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
			 if(MngDcm_GetSecurityAccessSts() != DCM_SECURITYACCESS_DEFAULT)
			 {
				 LaDcm_u_TempBuffer[2] = 0;
				 LaDcm_u_TempBuffer[3] = 0;
				 LaDcm_u_TempBuffer[4] = 0;
				 LaDcm_u_TempBuffer[5] = 0;	 
			 }
			 else
			 {
				SeDcm_w_SecurityAccessSeed = GetSeed();
				LaDcm_u_TempBuffer[2] = (uint8)(SeDcm_w_SecurityAccessSeed>>24)&0xFF;
				LaDcm_u_TempBuffer[3] = (uint8)(SeDcm_w_SecurityAccessSeed>>16)&0xFF;
				LaDcm_u_TempBuffer[4] = (uint8)(SeDcm_w_SecurityAccessSeed>>8)&0xFF;
				LaDcm_u_TempBuffer[5] = (uint8)SeDcm_w_SecurityAccessSeed&0xFF;
			 }
             SeDcm_u_SecurityAccessServerSts |= DCM_SASERVERSTS_REQUESTKEY;  /*27 Ϊ */
             
             SeDcm_u_SecurityAccessKey = GENERIC_ALGORITHM(SeDcm_w_SecurityAccessSeed,SecurityLevel);
         
             SetCanTp_TxBuffer(6U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;          /*ΪӦ*/
         }
         
     }
     else
     {
         /*NRC 37*/
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC37]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
       
     return LeDcm_u_Result;
 }
 
 
  /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_KeyCkeckDeal(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 27  ԿУ 

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_KeyCkeckDeal(uint8 dummy)
 {
     uint8 i;
     uint8 LaDcm_u_TempBuffer[2],savebuf[4];
     TeDcm_h_ResultType LeDcm_u_Result;
     uint32 LeDcm_w_Key;
   
     
     if(DCM_SASERVERSTS_REQUESTKEY & SeDcm_u_SecurityAccessServerSts)
     {
         SaDcm_u_RequestCounter = 0;
         KamData.SeedReqTimes = SaDcm_u_RequestCounter;
         for(i = 0;i < DCM_SASERVER_KEYLENGTH;i++)                   /*ȡͻ˷͹Կ*/
         {
             VeDcm_h_RqustInfo.Key[i] = VeDcm_P_DataAddress[i+2];
         }
     
         LeDcm_w_Key = ((uint32)VeDcm_h_RqustInfo.Key[0]<<24) + ((uint32)VeDcm_h_RqustInfo.Key[1]<<16) + ((uint32)VeDcm_h_RqustInfo.Key[2]<<8) + VeDcm_h_RqustInfo.Key[3];
         
         if(LeDcm_w_Key != SeDcm_u_SecurityAccessKey)               /*ԿУ*/
		 //if(LeDcm_w_Key != SeDcm_w_SecurityAccessSeed)               /*ԿУ*/
         {
             SeDcm_u_KeyErrorCount++;                             /*Կ Կ1*/                             
             KamData.KeyErrTimes = SeDcm_u_KeyErrorCount | 0x10;
             
             ReadFlashData(savebuf,0x000F1800,4);
        	 savebuf[0] = SaDcm_u_RequestCounter;
        	 savebuf[1] = SeDcm_u_KeyErrorCount;
        	 WriteDataflash(savebuf,0x000F1800,4);
        	 
         }
         else                               /*Կ֤ͨ*/
         {
             SeDcm_u_KeyErrorCount = 0U;                                /*Կ*/
             KamData.KeyErrTimes = SeDcm_u_KeyErrorCount;
             
             ReadFlashData(savebuf,0x000F1800,4);
        	 savebuf[0] = SaDcm_u_RequestCounter;
        	 savebuf[1] = SeDcm_u_KeyErrorCount;
        	 WriteDataflash(savebuf,0x000F1800,4);
        	 
			 if(dummy == 0x02)
				 SeDcm_u_SecurityAccessState = DCM_SECURITYACCESS_L1_UNLOCK;    /*ðȫȨΪ ״̬ */
			 else if(dummy == 0x12)
				 SeDcm_u_SecurityAccessState = DCM_SECURITYACCESS_L2_UNLOCK;    /*ðȫȨΪ ״̬ */
         }
     
         if(0 == SeDcm_u_KeyErrorCount)                                /*Կûд*/
         {
             if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))
             {
                 LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
                 LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
             
                 SeDcm_u_SecurityAccessServerSts = DCM_SECURITYACCESS_DEFAULT;  /*27 Ϊ Ĭ״̬ */
                 SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
                 LeDcm_u_Result = CeDcm_e_ResultPosRsp;
             }
             else
             {
                 SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
                 LeDcm_u_Result = CeDcm_e_ResultNoRsp;    
             }
             
     
         }
         else if(SeDcm_u_KeyErrorCount>0&&SeDcm_u_KeyErrorCount<DCM_SASERVER_KEYERRORCOUNT)    /*ԿΧ*/
         {
             /*NRC 35*/
             SeDcm_u_SecurityAccessServerSts = DCM_SECURITYACCESS_DEFAULT;  /*27 Ϊ Ĭ״̬ */
             MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC35]);    /*Ӧ*/
             SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNegRsp;
         
         }
         else                              
         {
             /*ԿΧ*/ /*NRC 36*/
             SeDcm_u_SecurityAccessServerSts = DCM_SECURITYACCESS_DEFAULT;       /*27 Ϊ Ĭ״̬ */
             SeDcm_u_KeyErrorDelayCount = DCM_SASERVERSTS_ERRORDELAY_COUNT;    /*Կ 27ʱ */
             MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC36]);    /*Ӧ*/
             SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNegRsp;
         }
                  
     }
     else
     {
         /*NRC 24*/
         SeDcm_u_SecurityAccessServerSts = DCM_SECURITYACCESS_DEFAULT;                 /*27 Ϊ Ĭ״̬ */
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
      
     
     return LeDcm_u_Result;
 }
 
 
/******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_RoutineFF02Start(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF02 ʼ   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_RoutineFF02Start(void)
 {
     uint8 LaDcm_u_TempBuffer[5];
     TeDcm_h_ResultType LeDcm_u_Result;
     
    
     if(CeDcm_e_RidStop == SeDcm_u_RidFF02Sts)
     {
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))                /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
             LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
             LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
			 LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
             
             SeDcm_u_RidFF02Sts = CeDcm_e_RidStart;                 /*̵ǰ״̬*/
             
             //ҪĻ  78
             //
			 RidFF02RunSts = Rid_Finish;
              
             SeDcm_u_RidFF02Sts = CeDcm_e_RidStop;                 /*̵ǰ״̬*/
     
             SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
			 SeDcm_u_RidFF02Sts = CeDcm_e_RidStart;                 /*̵ǰ״̬*/
             
             //ҪĻ  78
             //
			 RidFF02RunSts = Rid_Finish;
			 
             SeDcm_u_RidFF02Sts = CeDcm_e_RidStop;                 /*̵ǰ״̬*/
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         }
     }
     else
     {
         /*NRC 24*/
      
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
     
     return LeDcm_u_Result;
 }
 
RidRunSts_T GetRidFF02RunSts(void)
{
	return RidFF02RunSts;
}
 
  /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_RoutineFF00Start(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF00 ʼ   

 *༭ʱ    : 2015-11-03

 *ע        : 
 *****************************************************************************/ 
TeDcm_h_ResultType MngDcm_RoutineFF00Start(void)
{
	TeDcm_h_ResultType LeDcm_u_Result;
#if 0
    uint8 LaDcm_u_TempBuffer[5];
    TeDcm_h_ResultType LeDcm_u_Result;
     
    if(CeDcm_e_RidStop == SeDcm_u_RidFF00Sts)
    {
		// 78
		MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC78]);  
		SetCanTp_Tx_78Neg(3U,VaDcm_u_NegRspTxBuffer); 
		
		if(CeFCC_Programing_e_Succeed == SetFCC_Programing_EraseFlash(FCC_PROGRAMING_APPCODE_SECTORONE))
		{
			SetWd_FeedWdg();
		    // 78
			MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC78]);  
			SetCanTp_Tx_78Neg(3U,VaDcm_u_NegRspTxBuffer);    
			//
			SetFCC_Programing_EraseFlash(FCC_PROGRAMING_APPCODE_SECTORTWO);
			SetWd_FeedWdg();
			// 78
			MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC78]);  
			SetCanTp_Tx_78Neg(3U,VaDcm_u_NegRspTxBuffer);    
			//
			SetFCC_Programing_EraseFlash(FCC_PROGRAMING_APPCODE_SECTORTHR);
			
			if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))                /*жӦλ*/
			{
				LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
				LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
		
				LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
				LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
				LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
				 
				SeDcm_u_RidFF00Sts = CeDcm_e_RidStart;                 /*̵ǰ״̬*/
				 
				
				SeDcm_u_RidFF00Sts = CeDcm_e_RidStop;                 /*̵ǰ״̬*/
		 
				SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
				LeDcm_u_Result = CeDcm_e_ResultPosRsp;
			}
			else
			{
				SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
				LeDcm_u_Result = CeDcm_e_ResultNoRsp;
			}
		}
		else
		{
			MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC72]);    /*Ӧ*/
			SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
			LeDcm_u_Result = CeDcm_e_ResultNegRsp;
		}
    }
    else
    {
        /*NRC 24*/
        MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
        SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
        LeDcm_u_Result = CeDcm_e_ResultNegRsp;
    }
#endif     
    return LeDcm_u_Result;
 }
 
 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_RoutineFF01Start(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF01 ʼ   

 *༭ʱ    : 2015-10-10

 *ע        : 
*****************************************************************************/ 
TeDcm_h_ResultType MngDcm_RoutineFF01Start(void)
{
    uint8 LaDcm_u_TempBuffer[5];
    TeDcm_h_ResultType LeDcm_u_Result;
#if 0    
    if(CeDcm_e_RidStop == SeDcm_u_RidFF01Sts)
    {
		//
		MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC78]);  
		SetCanTp_Tx_78Neg(3U,VaDcm_u_NegRspTxBuffer);
		LeDcm_u_Result = CeDcm_e_ResultNegRsp;
		
		if(CeFCC_Programing_e_Succeed == SetFCC_Programing_Check())
		{
			if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))                /*жӦλ*/
			{
				LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
				LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
		 
				LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
				LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
				LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
				 
				SeDcm_u_RidFF01Sts = CeDcm_e_RidStart;                 /*̵ǰ״̬*/
				  
				SeDcm_u_RidFF01Sts = CeDcm_e_RidStop;                 /*̵ǰ״̬*/
		 
				SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
				LeDcm_u_Result = CeDcm_e_ResultPosRsp;
			}
			else
			{
				SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
				LeDcm_u_Result = CeDcm_e_ResultNoRsp;
			}
		}
		else
		{
			MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC72]);    /*Ӧ*/
			SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
			LeDcm_u_Result = CeDcm_e_ResultNegRsp;
		}		
    }
    else
    {
        /*NRC 24*/
        MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
        SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
        LeDcm_u_Result = CeDcm_e_ResultNegRsp;
    }
#endif    
    return LeDcm_u_Result;
}
 
 
  /******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_RoutineFF02Stop(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF02 ֹͣ   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_RoutineFF02Stop(void)
 {
     uint8 LaDcm_u_TempBuffer[5];
     TeDcm_h_ResultType LeDcm_u_Result;
     
      
     if(CeDcm_e_RidStart == SeDcm_u_RidFF02Sts)
     { 
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))      /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
             LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
             LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
		     LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
     
             SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         }
     }
     else
     {
         /*NRC 24*/
      
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
     
     return LeDcm_u_Result;
 }
 
 
  /******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_RoutineFF02Stop(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF00 ֹͣ   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_RoutineFF00Stop(void)
 {
     uint8 LaDcm_u_TempBuffer[5];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     if(CeDcm_e_RidStart == SeDcm_u_RidFF00Sts)
     { 
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))      /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
             LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
             LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
		     LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
     
             SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         }
     }
     else
     {
         /*NRC 24*/
      
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
     
     return LeDcm_u_Result;
 }
 
 
/******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_RoutineFF02Result(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF01 ֹͣ   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_RoutineFF01Stop(void)
 {
     uint8 LaDcm_u_TempBuffer[5];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     if(CeDcm_e_RidStart == SeDcm_u_RidFF01Sts)
     { 
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))      /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
             LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
             LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
		     LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
     
             SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         }
     }
     else
     {
         /*NRC 24*/
      
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
     
     return LeDcm_u_Result;
 }
 
 
 
/******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_RoutineFF02Result(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF02    

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_RoutineFF02Result(void)
 {
     uint8 LaDcm_u_TempBuffer[5];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     if(CeDcm_e_RidStop == SeDcm_u_RidFF02Sts)
     {
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))     /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
             LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
             LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
			 LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
     
             SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         }
     }
     else
     {
         /*NRC 24*/
      
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
     
     return LeDcm_u_Result;
 }
 
 
 /******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_RoutineFF00Result(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF00    

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_RoutineFF00Result(void)
 {
     uint8 LaDcm_u_TempBuffer[5];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     if(CeDcm_e_RidStop == SeDcm_u_RidFF00Sts)
     {
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))     /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
             LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
             LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
			 LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
     
             SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         }
     }
     else
     {
         /*NRC 24*/
      
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
     
     return LeDcm_u_Result;
 }
 
 /******************************************************************************
 *    :  TeDcm_h_ResultType MngDcm_RoutineFF01Result(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 31  FF01    

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_RoutineFF01Result(void)
 {
     uint8 LaDcm_u_TempBuffer[5];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     if(CeDcm_e_RidStop == SeDcm_u_RidFF01Sts)
     {
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))     /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
             LaDcm_u_TempBuffer[3] = VeDcm_h_RqustInfo.Rid&0xFF;
             LaDcm_u_TempBuffer[2] = VeDcm_h_RqustInfo.Rid>>8;
			 LaDcm_u_TempBuffer[4] = DCM_RIDRESULT_SUCCESS;
     
             SetCanTp_TxBuffer(5U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         }
     }
     else
     {
         /*NRC 24*/
      
         MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
         SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNegRsp;
     }
     
     return LeDcm_u_Result;
 }
 
 
 
TeDcm_h_ResultType MngDcm_RoutineF001Start(void) 
{

}
TeDcm_h_ResultType MngDcm_RoutineF001Stop(void)   
{

}
TeDcm_h_ResultType MngDcm_RoutineF001Result(void) 
{

}

 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_EnableCommunication(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 28 ͨѶ   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_CtrlCommunication(uint8  CommunicationType)
 {
     uint8 LaDcm_u_TempBuffer[2];
     TeDcm_h_ResultType LeDcm_u_Result;

     
     if(SeDcm_u_DiagnosticSession != DCM_EXTEND_SESSION)
     {
         if(DCM_FUNCTIONAL_ADDRESS == VeDcm_h_RqustInfo.RequstSty)
         {
            SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
            return  CeDcm_e_ResultNoRsp; 
         }
         else
         {
            MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC7F]);    /*Ӧ*/
            SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
            return  CeDcm_e_ResultNoRsp; 
            
         }
     }
     
     if( (CommunicationType >= 1) && ( CommunicationType <= 3))
	 {
         if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))      /*жӦλ*/
         {
             LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
             LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
    		
    		if( CommunicationType == 3)
    		{
    			SeDcm_u_NetworkMsgSts = 3 - VeDcm_h_RqustInfo.Sub;      /*շʹ*/
    			SeDcm_u_NormalMsgSts = 3 - VeDcm_h_RqustInfo.Sub;      /*Ӧñշʹ*/
    		}
    		else if(CommunicationType == 1)
    			SeDcm_u_NormalMsgSts = 3 - VeDcm_h_RqustInfo.Sub;      /*Ӧñշʹ*/
    		else 
    			SeDcm_u_NetworkMsgSts = 3 - VeDcm_h_RqustInfo.Sub;      /*շʹ*/
         
             SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
             LeDcm_u_Result = CeDcm_e_ResultPosRsp;
         }
         else
         {
             SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
             LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         }
     }
	 else
	 {
		 /*NRC 31*/
		 
         if(DCM_FUNCTIONAL_ADDRESS == VeDcm_h_RqustInfo.RequstSty)
         {
            SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
            LeDcm_u_Result =   CeDcm_e_ResultNoRsp; 
         }
         else
         {
            MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC31]);    /*Ӧ*/
            SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);                              /*ýӿڷӦ*/
            LeDcm_u_Result =   CeDcm_e_ResultNoRsp; 
            
         }
	 }
     
     return LeDcm_u_Result;
 }
 
 
 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_DisenableCommunication(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 28 ֹͨѶ   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_DisenableCommunication(void)
 {
     uint8 LaDcm_u_TempBuffer[2];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))        /*жӦλ*/
     {
         LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
         LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
         SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_DISENABLE;      /*շر*/
         SeDcm_u_NormalMsgSts = DCM_MSGTXRX_DISENABLE;       /*Ӧñշر*/
     
     
         SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultPosRsp;
     }
     else
     {
         SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_DISENABLE;      /*շر*/
         SeDcm_u_NormalMsgSts = DCM_MSGTXRX_DISENABLE;       /*Ӧñշر*/
         
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNoRsp;
     }
     
     return LeDcm_u_Result;
 }
 
 TeDcm_h_ResultType MngDcm_EnableCommunication(void)
 {
     uint8 LaDcm_u_TempBuffer[2];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     if(0x02 != VeDcm_h_RqustInfo.Sub)        /*жӦλ*/
     {
         LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
         LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
         SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;      /*շر*/
         SeDcm_u_NormalMsgSts = DCM_MSGTXRX_ENABLE | (DCM_MSGTXRX_ENABLE<<1);       /*Ӧñշر*/
     
     
         SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultPosRsp;
     }
     else
     {
         SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;      /*շر*/
         SeDcm_u_NormalMsgSts = DCM_MSGTXRX_ENABLE | (DCM_MSGTXRX_ENABLE<<1);      /*Ӧñշر*/
         
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         
     }
     
     return LeDcm_u_Result;
 }
 
 TeDcm_h_ResultType MngDcm_EnableCommunication_SID_0x29(void)
 {
     uint8 LaDcm_u_TempBuffer[2];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     if(0x02 != VeDcm_h_RqustInfo.Sub)        /*жӦλ*/
     {
         LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
         LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
         SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;      /*շر*/
         SeDcm_u_NormalMsgSts = DCM_MSGTXRX_ENABLE | (DCM_MSGTXRX_ENABLE<<1);       /*Ӧñշر*/
     
     
         SetCanTp_TxBuffer(1U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultPosRsp;
     }
     else
     {
         SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;      /*շر*/
         SeDcm_u_NormalMsgSts = DCM_MSGTXRX_ENABLE | (DCM_MSGTXRX_ENABLE<<1);      /*Ӧñշر*/
         
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNoRsp;
         
     }
     
     return LeDcm_u_Result;
 }
 
 uint8 GetNormalMsgSts(void)
 {
	return (SeDcm_u_NormalMsgSts);

 }
 
 uint8 GetNetworkMsgSts(void)
 {
	return(SeDcm_u_NetworkMsgSts);
 }
 
  unsigned char SX11GetNormalMsgSts(void)
 {
	return (3 - SeDcm_u_NormalMsgSts);
 }
 
 unsigned char SX11GetNetworkMsgSts(void)
 {
	return(3 - SeDcm_u_NetworkMsgSts);
 }
 
 

 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_TesterPresentDeal(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 3E    

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_TesterPresentDeal(void)
 {
     
     
     uint8 LaDcm_u_TempBuffer[2];
     TeDcm_h_ResultType LeDcm_u_Result;
     
     SeDcm_w_S3ServerTime = DCM_S3SEVERTIMEOUT;     /*S3serverʱ*/
     
     if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))   /*жӦλ*/
     {
         LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
         LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
     
         SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultPosRsp;
     }
     else
     {
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNoRsp;
     }
     
     return LeDcm_u_Result;
 }
 void resetS3Server(void)
 {
    SeDcm_w_S3ServerTime = DCM_S3SEVERTIMEOUT;     /*S3serverʱ*/
 }
 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_DTCSettingEnable(void)

 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 85   DTC ʹ   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_DTCSettingEnable(void)
 {
     uint8 LaDcm_u_TempBuffer[2];
     TeDcm_h_ResultType LeDcm_u_Result;
	 uint8 temp;

     if(DCM_FUNCTIONAL_ADDRESS == VeDcm_h_RqustInfo.RequstSty && (SeDcm_u_DiagnosticSession != DCM_EXTEND_SESSION))
     {
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         return  CeDcm_e_ResultNoRsp; 
     }
     
     SeDcm_u_DtcSetSts = DCM_DTCSET_ENABLE;
	 DtcStutasInit();
     
     if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))     /*жӦλ*/
     {
         LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
         LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
         SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultPosRsp;
     }
     else
     {
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNoRsp;
     }
    
     return LeDcm_u_Result;
 }
 
 
  /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_DTCSettingDisenable(void)
 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 85   DTC ýֹ   

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 TeDcm_h_ResultType MngDcm_DTCSettingDisenable(void)
 {
     uint8 LaDcm_u_TempBuffer[2];
     TeDcm_h_ResultType LeDcm_u_Result;

     if(DCM_FUNCTIONAL_ADDRESS == VeDcm_h_RqustInfo.RequstSty && (SeDcm_u_DiagnosticSession != DCM_EXTEND_SESSION))
     {
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         return  CeDcm_e_ResultNoRsp; 
     }
     
     SeDcm_u_DtcSetSts = DCM_DTCSET_DISENABLE; 
     
     if(DCM_FALSE == (VeDcm_h_RqustInfo.Sub&0x80))     /*жӦλ*/
     {
         LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
         LaDcm_u_TempBuffer[1] = VeDcm_h_RqustInfo.Sub;
     
         SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);      /*ýӿڷӦ*/
         LeDcm_u_Result = CeDcm_e_ResultPosRsp;
     }
     else
     {
         SetCanTp_TxBuffer(0U,LaDcm_u_TempBuffer);      /*ýӿڷӦ 0ΪӦ*/
         LeDcm_u_Result = CeDcm_e_ResultNoRsp;
     }
    
     return LeDcm_u_Result;
 }
 
 
 uint8 GetDtcEnable(void)
 {
	return SeDcm_u_DtcSetSts;
 }
 
 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_DynamicaDefineNewDid(void)
 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 2C  ¶̬DID   

 *༭ʱ    : 2016-12-25

 *ע        : 
 *****************************************************************************/  
 
 TeDcm_h_ResultType MngDcm_DynamicaDefineNewDid(void)
 {
	 TeDcm_h_ResultType LeDcm_u_Result;
	 /*NRC22*/
	 MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC22]);    /*Ӧ*/
	 SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
	 LeDcm_u_Result = CeDcm_e_ResultNegRsp;      /*Ӧ*/
	return LeDcm_u_Result;
 }
 
 /******************************************************************************
 *    : TeDcm_h_ResultType MngDcm_ClearDynamicaDid(void)
 *        : void

 *ֵ      : LeDcm_u_Result    

 *        : 2C  ¶̬DID   

 *༭ʱ    : 2016-12-25

 *ע        : 
 *****************************************************************************/  
 
 TeDcm_h_ResultType MngDcm_ClearDynamicaDid(void)
 {
	 TeDcm_h_ResultType LeDcm_u_Result;
	 /*NRC22*/
	 MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC22]);    /*Ӧ*/
	 SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
	 LeDcm_u_Result = CeDcm_e_ResultNegRsp;      /*Ӧ*/
	 return LeDcm_u_Result;
 }
 
 /******************************************************************************
 *    : void MngDcm_ChangeToDefaltSession(void)
 
 *        : void

 *ֵ      : void   

 *        : ת ĬϻỰģʽ    

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/  
void MngDcm_ChangeToDefaltSession(void)
{
    SeDcm_u_S3ServerTimeSts = DCM_S3SEVERTIMER_STOP;         /*S3server ʱֹͣ*/
    SeDcm_u_DiagnosticSession = DCM_DEFAULT_SESSION;       /*Ựģʽ Ĭģʽ*/
    SeDcm_u_SecurityAccessState = DCM_SECURITYACCESS_DEFAULT;  /*ȫģʽ*/
    SeDcm_u_DtcSetSts = DCM_DTCSET_ENABLE;                   /*DTCʹ*/
    SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;              /*շʹ*/
    SeDcm_u_NormalMsgSts = DCM_MSGTXRX_ENABLE | (DCM_MSGTXRX_ENABLE<<1);              /*Ӧñշʹ*/      
	//CleanIoDid();
}

 /******************************************************************************
 *    : void MngDcmS3ServerAndKeyErrorCountCutDown(void)
 
 *        : void

 *ֵ      : void   

 *        : S3ServerTime Լ    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/  
void MngDcmS3ServerCountCutDown(void)
{
    if(SeDcm_w_S3ServerTime > 0)
    {
        SeDcm_w_S3ServerTime--;
    }   
    
} 


/******************************************************************************
 *    : void MngDcmKeyErrorDelayCountCutDown(void)
 
 *        : void

 *ֵ      : void   

 *        : Կ󳬳 ʱ Լ    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/  
void MngDcmKeyErrorDelayCountCutDown(void)
{
    unsigned char savebuf[4];
    if(SeDcm_u_KeyErrorDelayCount > 0)
    {
        SeDcm_u_KeyErrorDelayCount--; 
        if(SeDcm_u_KeyErrorDelayCount == 0)
        {
            SeDcm_u_KeyErrorCount = 0U;  
            KamData.KeyErrTimes = SeDcm_u_KeyErrorCount;
            ReadFlashData(savebuf,0x000F1800,4);
        	 savebuf[0] = SaDcm_u_RequestCounter;
        	 savebuf[1] = SeDcm_u_KeyErrorCount;
        	 WriteDataflash(savebuf,0x000F1800,4);
        }
    }
    if(SaDcm_u_RequestDelayCount > 0)
    {
        SaDcm_u_RequestDelayCount--;
        if(SaDcm_u_RequestDelayCount == 0)
        {
            SaDcm_u_RequestCounter = 0U;
            KamData.SeedReqTimes = SaDcm_u_RequestCounter;
            ReadFlashData(savebuf,0x000F1800,4);
        	 savebuf[0] = SaDcm_u_RequestCounter;
        	 savebuf[1] = SeDcm_u_KeyErrorCount;
        	 WriteDataflash(savebuf,0x000F1800,4);
        }
    }
} 





/******************************************************************************
 *    : void MngDcm_PrepareNegRsp(uint8 LeDcm_u_Sid,uint8 LeDcm_u_Nrc)
 
 *        : LeDcm_u_Sid sid  ҪӦNRC

 *ֵ      : void   

 *        : Ӧ 
    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/  
void MngDcm_PrepareNegRsp(uint8 LeDcm_u_Sid,uint8 LeDcm_u_Nrc)
{
   VaDcm_u_NegRspTxBuffer[0] = 0x7F;                   /*Ӧ*/
   VaDcm_u_NegRspTxBuffer[1] = LeDcm_u_Sid;            /*sid*/
   VaDcm_u_NegRspTxBuffer[2] = LeDcm_u_Nrc;            /*NRC*/
}



/******************************************************************************
 *    : void MngDcm_PrepareNegRsp(uint8 LeDcm_u_Sid,uint8 LeDcm_u_Nrc)
 
 *        : TargetAddress  Ŀ飬TargetPost ĿʼλãSourceAddress Դ飬SourcePost Դλã
                DataLength     ƶݳ

 *ֵ      : void   

 *        : ƶ   
    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/  
void MngDcm_DataMoveDeal(uint8* TargetAddress,uint8 TargetPost,uint8* SourceAddress,uint8 SourcePost,uint8 DataLength)
{
    
    uint8 i;
 
    for(i = 0;i < DataLength; i ++)
    {
        TargetAddress[TargetPost + i] = SourceAddress[SourcePost + i];
              
    }
   
}


 /******************************************************************************
 *    :TeDcm_h_ResultType MngDcm_RequestDownloadService(void)
 
 *        : void
               
 *ֵ      : LeDcm_u_FinallyResult  

 *        : 34 

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
TeDcm_h_ResultType MngDcm_RequestDownloadService(void)
{
    uint8 LeDcm_u_dataFomatldentifier;                 /*ݸʽ*/  
    uint8 LeDcm_u_addressAndLengthFomatldentifier;     /*ַݳȸʽ*/ 
    uint32 LeDcm_w_Address;                            /*ַ*/ 
    uint32 LeDcm_w_DataLength;                         /*ݳ*/    
    uint8 LeDcm_u_SidIndex;
    uint8 LeDcm_u_SecurityAccessCheckResult;
    uint8 LaDcm_u_TempBuffer[6];
    TeDcm_h_ResultType LeDcm_u_FinallyResult; 
#if 0   
    
    LeDcm_u_dataFomatldentifier = VeDcm_P_DataAddress[1];  
    LeDcm_u_addressAndLengthFomatldentifier = VeDcm_P_DataAddress[2];
    
    /*ȡַ*/ 
    LeDcm_w_Address = (((uint32)VeDcm_P_DataAddress[3])<<24U) + (((uint32)VeDcm_P_DataAddress[4])<<16U) + (((uint32)VeDcm_P_DataAddress[5])<<8U) + VeDcm_P_DataAddress[6];
    /*ȡݳ*/ 
    LeDcm_w_DataLength = (((uint32)VeDcm_P_DataAddress[7])<<24U) + (((uint32)VeDcm_P_DataAddress[8])<<16U) + (((uint32)VeDcm_P_DataAddress[9])<<8U) + VeDcm_P_DataAddress[10];
    
    if((DCM_DATAFOMATLDENTIFER == LeDcm_u_dataFomatldentifier)&&(LeDcm_u_addressAndLengthFomatldentifier == DCM_ADDRESSANDLENGTHFOMATLDENTIFER))
    {
        if(VeDcm_h_RqustInfo.DL == 11U)
        {
            if(CeFCC_Programing_e_Succeed == SetFCC_Programing_AddrSize(LeDcm_w_Address,LeDcm_w_DataLength))
            {
                LeDcm_u_SidIndex = MngDcm_SIDCheckAvailable(VeDcm_h_RqustInfo.Sid);
                LeDcm_u_SecurityAccessCheckResult = MngDcm_SIDCheckSecurityAccess(LeDcm_u_SidIndex);
                if(DCM_CHECK_OK == LeDcm_u_SecurityAccessCheckResult)
                {
                    LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
                    LaDcm_u_TempBuffer[1] = DCM_LENGTHFOMATLDENTIFER; 
                    LaDcm_u_TempBuffer[3] = CaDcm_w_SingleAllowDateLength&0xFF;      /* ֽ*/
                    LaDcm_u_TempBuffer[2] = CaDcm_w_SingleAllowDateLength>>8;         /* ֽ*/
                    SetCanTp_TxBuffer(4U,LaDcm_u_TempBuffer);                         /*ýӿڷӦ*/
                    SeDcm_u_DownLoadDataSts = CeDcm_e_DownLoadRequested;              /*״̬Ϊ  */
                    SeDcm_w_DownLoadDataLength = LeDcm_w_DataLength;                  /*¼ 34 صݳ*/
                    SeDcm_w_TransmitDataCount = 0U;
                    LeDcm_u_FinallyResult = CeDcm_e_ResultPosRsp;
                } 
                else
                {
                     MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC33]);    /*Ӧ*/
                     SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
                     LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
                }
             }
             else
             {
                 MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC31]);    /*Ӧ*/
                 SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
                 LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
             }
        }
        else
        {
            MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC13]);    /*Ӧ*/
            SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
            LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
        }
    }
    else
    {
        MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC31]);    /*Ӧ*/
        SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
        LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
    }
#endif    
    return  LeDcm_u_FinallyResult;
}


 /******************************************************************************
 *    :
 
 *        : void
               
 *ֵ      : LeDcm_u_FinallyResult  

 *        : 36 

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 

TeDcm_h_ResultType MngDcm_TransmitDataService(void)
{
    uint16 LeDcm_w_SingleTransmitDataCount;
    uint8  LeDcm_u_BlockSequenceCount;
	uint8  LeDcm_u_BlockExpect;
    uint8  LaDcm_u_TempBuffer[6];                                 /*Ӧݻ*/
    TeDcm_h_ResultType LeDcm_u_FinallyResult;
#if 0
	TeFCC_Programing_e_Result LeDcm_FCC_Ret;
    
    if(CeDcm_e_DownLoadRequested==SeDcm_u_DownLoadDataSts||CeDcm_e_DownLoadDuringTransmit == SeDcm_u_DownLoadDataSts)
    {
        LeDcm_w_SingleTransmitDataCount = VeDcm_h_RqustInfo.DL - 2U;               /*ȡ  ޳ֽ*/
        SeDcm_w_TransmitDataCount = SeDcm_w_TransmitDataCount + LeDcm_w_SingleTransmitDataCount;     /*¼*/
        /*жϴۼǷ񳬹 ص   δ䳤Ƿ񳬳 34Ӧ*/
        if(SeDcm_w_TransmitDataCount <= SeDcm_w_DownLoadDataLength)
        {
            LeDcm_u_BlockSequenceCount = VeDcm_P_DataAddress[1];                  /*ȡ 36  BlockSequenceCount*/
			LeDcm_u_BlockExpect = (uint8)(((uint16)SeDcm_u_BlockSequenceCountSts + 1)&0x00ff);
			
            if(((0x01 == LeDcm_u_BlockSequenceCount)&&(SeDcm_u_DownLoadDataSts == CeDcm_e_DownLoadRequested))
            || ((LeDcm_u_BlockSequenceCount== LeDcm_u_BlockExpect)&&(SeDcm_u_DownLoadDataSts == CeDcm_e_DownLoadDuringTransmit)))
            {
				if(VeDcm_h_RqustInfo.DL <= CaDcm_w_SingleAllowDateLength)/*MaxNumberofBlockLength*/
				{
					SeDcm_u_BlockSequenceCountSts = LeDcm_u_BlockSequenceCount;
					SeDcm_u_DownLoadDataSts = CeDcm_e_DownLoadDuringTransmit;     /*״̬Ϊ  ڴ*/
					
					 if(SeDcm_w_TransmitDataCount == SeDcm_w_DownLoadDataLength)  
					{
						SeDcm_u_DownLoadDataSts = CeDcm_e_DownLoadTransmited;     /*״̬Ϊ  */
						SeDcm_w_TransmitDataCount = 0U;  
					}
					
					//78Ӧ
					MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC78]);    /*Ӧ*/
					SetCanTp_Tx_78Neg(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
					LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
					
					//ýӿ 
					LeDcm_FCC_Ret = SetFCC_Programing_Code(VeDcm_h_RqustInfo.DL-2,&VeDcm_P_DataAddress[2]);
					
					if(LeDcm_FCC_Ret == CeFCC_Programing_e_Succeed)
					{
						LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
						LaDcm_u_TempBuffer[1] = LeDcm_u_BlockSequenceCount;
						SetCanTp_TxBuffer(2U,LaDcm_u_TempBuffer);                         /*ýӿڷӦ*/
						LeDcm_u_FinallyResult = CeDcm_e_ResultPosRsp;
					}
					else
					{
						MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC31]);    /*Ӧ*/
						SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
						LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
					}		
				}
				else
				{
					MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC31]);    /*Ӧ*/
					SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
					LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
				}
            }
            else
            {
                MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC73]);    /*Ӧ*/
                SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
                LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
                
            }
        
        }
        else
        {
            MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC71]);    /*Ӧ*/
            SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
            LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
        }
    }
    else
    {
        MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
        SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
        LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
    }
#endif    
    return  LeDcm_u_FinallyResult;
}

 /******************************************************************************
 *    :
 
 *        : void
               
 *ֵ      : LeDcm_u_FinallyResult  

 *        : 37 

 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/ 
 
TeDcm_h_ResultType MngDcm_TransmitExitService(void)
{
    uint8 LaDcm_u_TempBuffer[2];
    TeDcm_h_ResultType LeDcm_u_FinallyResult;
    if(SeDcm_u_DownLoadDataSts == CeDcm_e_DownLoadTransmited)
    {
        if(VeDcm_h_RqustInfo.DL == 1U)
        {   
            LaDcm_u_TempBuffer[0] = LaDcm_u_TempBuffer[0] = VeDcm_h_RqustInfo.Sid + 0x40;
            SetCanTp_TxBuffer(1U,LaDcm_u_TempBuffer);                         /*ýӿڷӦ*/
            SeDcm_u_DownLoadDataSts = CeDcm_e_DownLoadRelax;                  /*״̬Ϊ  ˳ ״̬*/
#if 0			
			SetFCC_Programing_Finish();
#endif
        }
        else
        {
            MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC13]);    /*Ӧ*/
            SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
            LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
        }
        
    }
    else
    {
        MngDcm_PrepareNegRsp(VeDcm_h_RqustInfo.Sid,CaDcm_u_NRCData[DCM_NRC24]);    /*Ӧ*/
        SetCanTp_TxBuffer(3U,VaDcm_u_NegRspTxBuffer);      /*ýӿڷӦ*/
        LeDcm_u_FinallyResult = CeDcm_e_ResultNegRsp;      /*Ӧ*/
    }
    
    return  LeDcm_u_FinallyResult;
}


/******************************************************************************
 *    : void InitDcm_Parameter (void)
 
 *        : void 
 
 *ֵ      : void   

 *        : DCM ʼ
    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/  
 void InitDcm_Parameter (void)
 {
    unsigned char readbuf[33];
    SeDcm_u_DiagnosticSession = DCM_DIAGNOSTIC_SESSION_DEFAULT;     /*Ựģʽ  ĬϻỰ*/
    SeDcm_u_SecurityAccessState = DCM_SECURITYACCESS_DEFAULT;     /*ȫģʽ  ״̬*/
    SeDcm_u_DtcSetSts = DCM_DTCSET_ENABLE;                        /*DTCʹ*/
    SeDcm_u_NetworkMsgSts = DCM_MSGTXRX_ENABLE;                   /*շʹ*/
    SeDcm_u_NormalMsgSts = DCM_MSGTXRX_ENABLE |(DCM_MSGTXRX_ENABLE<<1);                  /*Ӧñշʹ*/   
    SeDcm_u_KeyErrorDelayCount = 0;//DCM_SASERVERSTS_ERRORDELAY_COUNT_DEFAULT;  /*Ĭ27ϵʱ*/  
    SeDcm_u_SecurityAccessServerSts = DCM_SECURITYACCESS_DEFAULT;  /*27 Ϊ Ĭ״̬ */
    SeDcm_u_KeyErrorCount = 0U;                                 /*27 ԿʼΪ0 */

    //SaDcm_u_RequestCounter = KamData.SeedReqTimes;
    //SeDcm_u_KeyErrorCount = KamData.KeyErrTimes;            /*ȡĴ*/
    ReadFlashData(readbuf,0x000F1800,4);

    SaDcm_u_RequestCounter = readbuf[0];
    SeDcm_u_KeyErrorCount = readbuf[1];            /*ȡĴ*/
    
    if(SaDcm_u_RequestCounter > 6)SaDcm_u_RequestCounter=0;
    if(SeDcm_u_KeyErrorCount > 4)SeDcm_u_KeyErrorCount=0;
    /*
    if((SaDcm_u_RequestCounter>>4)==0x01)SaDcm_u_RequestCounter &= 0x0F; 
    else SaDcm_u_RequestCounter = 0;

    if((SeDcm_u_KeyErrorCount>>4)==0x01)SeDcm_u_KeyErrorCount &= 0x0F; 
    else SeDcm_u_KeyErrorCount = 0;
    */
    if(SeDcm_u_KeyErrorCount >= 3  )
    {
        SeDcm_u_KeyErrorDelayCount = DCM_SASERVERSTS_ERRORDELAY_COUNT;
	//SaDcm_u_RequestCounter=5;
    }
    
    SeDcm_u_DownLoadDataSts = CeDcm_e_DownLoadRelax;             /*ش״̬Ϊ */
    
    SeDcm_u_RidFF02Sts = CeDcm_e_RidStop;                       /*̳ʼ״̬*/
    SeDcm_u_RidFF00Sts = CeDcm_e_RidStop;
    SeDcm_u_RidFF01Sts = CeDcm_e_RidStop;
	
	RidFF02RunSts = Rid_Idle;
	//DtcInit();
 }

/******************************************************************************
 *    : uint16 MngDcm_GetS3serverTime()
 
 *        : void 
 
 *ֵ      : SeDcm_w_S3ServerTime     S3ServerTimeǰֵ 

 *        : ȡS3ServerTimeǰֵ
    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/   
uint16 MngDcm_GetS3serverTime(void)
{
    return SeDcm_w_S3ServerTime;
} 

void MngDcm_ResetS3serverTime(void)
{
	SeDcm_w_S3ServerTime = DCM_S3SEVERTIMEOUT;
}
/******************************************************************************
 *    : uint8 MngDcm_GetS3serverTimeSts(void)
 
 *        : void 
 
 *ֵ      : SeDcm_u_S3ServerTimeSts     S3ServerTimeǰ  ״̬ 

 *        : ȡS3ServerTimeǰ  ״̬
    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/   
uint8 MngDcm_GetS3serverTimeSts(void)
{
    return SeDcm_u_S3ServerTimeSts;
} 


/******************************************************************************
 *    :uint8 MngDcm_GetDiagnosticSession(void)
 
 *        : void 
 
 *ֵ      : SeDcm_u_DiagnosticSession     ǰỰģʽ

 *        : ȡǰỰģʽ
    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/   
uint8 MngDcm_GetDiagnosticSession(void)
{
    return SeDcm_u_DiagnosticSession;
}

/******************************************************************************
 *    :uint8 MngDcm_GetSecurityAccessSts(void)
 
 *        : void 
 
 *ֵ      : SeDcm_u_SecurityAccessState     ǰȫȨ

 *        : ȡǰȫȨ
    
 *༭ʱ    : 2015-10-10

 *ע        : 
 *****************************************************************************/   
uint8 MngDcm_GetSecurityAccessSts(void)
{
    return SeDcm_u_SecurityAccessState;
}
 
