/******************************************************************************
|  File Name :  @ļ
|  Description: @ļ
******************************************************************************/
#ifndef   _DCM_KEY_H
#define   _DCM_KEY_H

/******************************************************************************
 * Description:     : Include File Section 									
******************************************************************************/
#include "DCM_Types.h"


/******************************************************************************
 * Description:     : Macro Description Section
******************************************************************************/

typedef  uint32 UWord32;

typedef union{
	uint32 word;
	uint8 byte[4];
}SeedSec_t;

/******************************************************************************
 * Description:     : Global Variable Declaration Section
******************************************************************************/

extern UWord32 seedToKey(UWord32 seed,UWord32 MASK);

extern uint32 GENERIC_ALGORITHM(uint32 wSeed, uint8 SecurityLevel);

extern uint32 GetSeed(void);

extern uint32 GetTimerCnt(void);
#endif
