
#ifndef __HWCTRL_H__
#define __HWCTRL_H__
#include "r_cg_macrodriver.h"

#include "PINdef.h"


#define KEY_PRESSED 1
#define KEY_NOPRESSED 0

#define LH_STATE_L  0
#define LH_STATE_H  1
#define FNR_STATE_N     0
#define FNR_STATE_F     1
#define FNR_STATE_R     2
#define FNR_ALL_LIGHT   3

#define P_LIGHT_NONE    0
#define P_LIGHT_RED     1
#define P_LIGHT_YELLOE  2

uint8_t GetKeyState(uint8_t keyno);
void KeyScan(void);
uint8_t GetIOState(uint8_t keyno);

void ad_handle(void);
uint16_t getAdval(ADCH_type ch);
void ClearKeyState(void);
uint8_t getKeyReleaseFlag(uint8_t id);
uint8_t getKeyPressFlag(uint8_t id);
void getInputStatus(unsigned char* data);
void IND_Ctrl(uint8_t fnr_state);
void P_light_Ctrl(uint8_t state);
void RE1LED_CTRL(uint8_t state);
void RE2LED_CTRL(uint8_t state);

#endif
